#include <bits/stdc++.h>

using namespace std;

#define int long long

const int mod = 1e9 + 7;

int add(int a, int b) { return (a + b >= mod ? a + b - mod : a + b); }
int sub(int a, int b) { return (a - b < mod ? a - b + mod : a - b); }
int mul(int a, int b) { return (long long)(a) * (long long)(b) % mod; }

void sadd(int& a, int b) { a = add(a, b); }
void ssub(int& a, int b) { a = sub(a, b); }
void smul(int& a, int b) { a = mul(a, b); }

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    string a[n];
    for(int i = 0; i < n; i++) cin >> a[i];
    int dp[n][m];
    for(int i = 0; i < n; i++) for(int j = 0; j < m; j++) dp[i][j] = 0;
    for(int i = 0; i < m; i++) {
        if(a[n - 1][i] == '0') dp[n - 1][i] = 1;
        else dp[n - 1][i] = 0;
    }
    int prefix[n][m];
    for(int i = 0; i < n; i++) for(int j = 0; j < m; j++) prefix[i][j] = 0;
    for(int i = 0; i < n; i++) {
        prefix[i][0] = (a[i][0] == '1');
        for(int j = 1; j < m; j++) prefix[i][j] = prefix[i][j - 1] + (a[i][j] == '1');
    }
    int pref[m];
    pref[0] = dp[n - 1][0];
    for(int i = 1; i < m; i++) pref[i] = add(pref[i - 1], dp[n - 1][i]);
    for(int i = n - 2; i >= 0; i--) {
        for(int j = 0; j < m; j++) {
            if(a[i][j] == '1') continue;
            int l = 0, r = j;
            int ans = r;
            while(l <= r) {
                int mid = (l + r) >> 1;
                int x = prefix[i + 1][j] - (mid > 0 ? prefix[i + 1][mid - 1] : 0);
                if((j + k < m ? prefix[i + 1][j + k] : prefix[i + 1][m - 1]) - prefix[i + 1][j] + x <= min(k, m - 1 - j)) {
                    ans = mid;
                    r = mid - 1;
                } else l = mid + 1;
            }
            sadd(dp[i][j], pref[j] - (ans > 0 ? pref[ans - 1] : 0));
            l = j;
            r = m - 1;
            ans = l;
            while(l <= r) {
                int mid = (l + r) >> 1;
                int x = prefix[i + 1][mid] - (j > 0 ? prefix[i + 1][j - 1] : 0);
                if((j > 0 ? prefix[i + 1][j - 1] : 0) - (j - k - 1 >= 0 ? prefix[i + 1][j - k - 1] : 0) + x <= min(k, j)) {
                    ans = mid;
                    l = mid + 1;
                } else r = mid - 1;
            }
            sadd(dp[i][j], (ans < m ? pref[ans] : pref[m - 1]) - pref[j]);
        }
        pref[0] = dp[i][0];
        for(int j = 1; j < m; j++) pref[j] = add(pref[j - 1], dp[i][j]);
    }
    int rez = 0;
    for(int i = 0; i < m; i++) sadd(rez, dp[0][i]);
    cout << rez;
    return 0;
}