#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 10;
const int LOG = 19;
int n;
vector<int> g[N];
int dp[N], dep[N];
vector<int> path;
int dist[N];
int fst, lst;
int tin[N], tout[N];
int timer;
int st[N][LOG];
int rez = 1e9;
int x1, x2, x3;

void dfs(int u, int par) {
    st[u][0] = par;
    tin[u] = timer++;
    if(par) dist[u] = dist[par] + 1;
    for(int v : g[u]) {
        if(v == par) continue;
        dfs(v, u);
        dep[u] = max(dep[u], dep[v] + 1);
    }
    tout[u] = timer++;
}

void dfs2(int u, int par) {
    int mx1 = 0, mx2 = 0;
    for(int v : g[u]) {
        if(v == par) continue;
        dfs2(v, u);
        mx2 = max(mx2, dep[v]);
        if(mx1 < mx2) swap(mx1, mx2);
    }
    dp[u] = mx1 + mx2 + 1;
}

void dfs3(int u, int par) {
    path.push_back(u);
    for(int v : g[u]) {
        if(v == par) continue;
        if(dep[v] != dep[u] - 1) continue;
        dfs3(v, u);
        break;
    }
}

bool is_ancestor(int u, int v) { return tin[u] < tin[v] && tout[u] > tout[v]; }

int LCA(int u, int v) {
    if(is_ancestor(u, v)) return u;
    if(is_ancestor(v, u)) return v;
    for(int j = LOG - 1; j >= 0; j--) {
        if(is_ancestor(st[u][j], v)) continue;
        u = st[u][j];
    }
    return st[u][0];
}

int Dist(int u, int v) { return dist[u] + dist[v] - 2 * dist[LCA(u, v)] + 1; }

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for(int i = 1; i <= n; i++) dp[i] = dep[i] = 1;
    dfs(1, 0);
    dfs2(1, 0);
    for(int j = 1; j < LOG; j++) for(int i = 1; i <= n; i++) st[i][j] = st[st[i][j - 1]][j - 1];
    int root = 1;
    for(int i = 2; i <= n; i++) if(dp[i] > dp[root]) root = i;
    int mx1 = 0, mx2 = 0;
    for(int u : g[root]) {
        if(dep[u] > dep[root]) continue;
        if(dep[u] > dep[mx2]) mx2 = u;
        if(dep[mx1] < dep[mx2]) swap(mx1, mx2);
    }
    if(mx1) dfs3(mx1, root);
    reverse(path.begin(), path.end());
    path.push_back(root);
    if(mx2) dfs3(mx2, root);
    fst = path[0];
    lst = path.back();
    for(int i = 1; i <= n; i++) {
        for(int j = i + 1; j <= n; j++) {
            for(int k = 1; k <= n; k++) {
                int mx = 0;
                mx = max(mx, min(Dist(k, fst), min(Dist(k, i) + Dist(j, fst), Dist(k, j) + Dist(i, fst))));
                mx = max(mx, min(Dist(k, lst), min(Dist(k, i) + Dist(j, lst), Dist(k, j) + Dist(i, lst))));
                if(rez > mx) {
                    x1 = i;
                    x2 = j;
                    x3 = k;
                }
                rez = min(rez, mx);
            }
        }
    }
    cout << x1 << " " << x2 << "\n" << x3;
    return 0;
}