#include <iostream>
#include <vector>
using namespace std;
typedef unsigned long long ull;

int m,n,k;

ull prebroj(bool slob[], int i, int j){
    if(i<0 || slob[i*m+j]){
        return 0;
    }
    
    if(i==0){
        return 1;
    }
    
    ull to_return = 0;
    
    for(l=j-1;l>=0 && !slob[i*m + l];l--){
        to_return += prebroj(slob,i-1,l);
        to_return%=konstanta;
    }
    
    
    for(h=j+1;h<m && !slob[i*m + h];h++){
        to_return += prebroj(slob,i-1,h);
        to_return%=konstanta;
    }
    
    return to_return;
}

const ull konstanta = 1000000007;

int main()
{
    cin>>n>>m>>k;
    getchar();
    bool slob[n*m];
    bool prazna = true;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            char c = getchar();
            slob[i*m+j] = !(c=='0');
            if(slob[i*m+j]){
                prazna = false;
            }
        }
        getchar();
    }

    if(prazna){
        ull proizvod = 1;
        for(int i=0;i<n;i++){
            proizvod *= m;
            proizvod %= konstanta;
        }
        cout<<proizvod;
    }
    else{
        ull zbir = 0;
        for(int j=0;j<m;j++){
            zbir += prebroj(slob,n-1,j);
            zbir %= konstanta;
        }
        cout<<zbir;
    }

    return 0;
}