#include <iostream>
#include <vector>
using namespace std;
typedef unsigned long long ull;

int m,n,k;
const ull konstanta = 1000000007;

ull prebroj(bool slob[], int i, int j){
    if(i<0 || slob[i*m+j]){
        return 0;
    }

    if(i==0){
        return 1;
    }

    ull to_return = 0;

    for(int l=j-1;l>=0 && !slob[i*m + l];l--){
        to_return += prebroj(slob,i-1,l);
        to_return%=konstanta;
    }


    for(int h=j+1;h<m && !slob[i*m + h];h++){
        to_return += prebroj(slob,i-1,h);
        to_return%=konstanta;
    }

    return to_return;
}
ull prebroj(bool slob[]){
    ull matrica[n][m];

    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            matrica[i][j]=0;
        }
    }

    for(int i=0;i<m;i++){
        if(slob[m + i])
        matrica[1][i] = matrica[0][i];
    }


    for(int i=2;i<n;i++){
        int l=0,h=0;
        while(l<m){
            while(!slob[(i-1)*m+l]){
                l++;
            }
            ull suma = 0;
            for(h=l;h<m&&slob[(i-1)*m+h];h++){
                suma += matrica[i-1][h];
                suma%=konstanta;
            }
            for(int brojac = l;brojac<h;brojac++){
                if(slob[i*m+brojac]){
                    matrica[i][brojac]=suma;
                }
            }
            l=h;
        }
    }

    ull suma = 0;
    for(int i=0;i<m;i++){

        suma+=matrica[n-1][i];
        suma%=konstanta;
    }


    return suma;
}

int main()
{
    cin>>n>>m>>k;
    getchar();
    bool slob[n*m];
    bool prazna = true;
    for(int i=0;i<n;i++){
        for(int j=0;j<m;j++){
            char c = getchar();
            slob[i*m+j] = !(c=='0');
            if(slob[i*m+j]){
                prazna = false;
            }
        }
        getchar();
    }

    if(prazna){
        ull proizvod = 1;
        for(int i=0;i<n;i++){
            proizvod *= m;
            proizvod %= konstanta;
        }
        cout<<proizvod;
    }
    else{
        ull zbir = 0;
        for(int j=0;j<m;j++){
            zbir += prebroj(slob,n-1,j);
            zbir %= konstanta;
        }
        cout<<zbir;
    }

    return 0;
}