#include <iostream>
#include <vector>
#include <list>

using namespace std;

int dfs(int n, int i, list<int> graf[], bool poseceni[], int dubina = 0)
{
    poseceni[i]=true;
    int maks = dubina;
    for(int j : graf[i]){
        if(!poseceni[j]){
            int score = dfs(n,j,graf,poseceni,dubina+1);
            if(score > maks){
                maks = score;
            }
        }
    }
    poseceni[i]=false;
    return maks;
}

int bfs(int n, int k, list<int> graf[]){
    bool poseceni[n];
    for(int i=0;i<n;i++){
        poseceni[i]=false;
    }
    poseceni[k]=true;
    list<int> cvorovi_stari;
    cvorovi_stari.push_back(k);
    list<int> cvorovi;
    int counter = 0;
    for(;cvorovi_stari.size()>0;counter++){
        for(int i:cvorovi_stari){
            for(int j:graf[i]){
                if(!poseceni[j]){
                    cvorovi.push_back(j);
                    poseceni[j]=true;
                }
            }
        }
        cvorovi_stari = cvorovi;
        cvorovi = list<int>();
    }
    return counter-1;
}

int main()
{
    int n;
    cin>>n;
    list<int> graf[n];
    for(int i=0;i<n-1;i++){
        int u,v;
        cin>>u>>v;

        graf[u-1].push_back(v-1);
        graf[v-1].push_back(u-1);
    }
    bool poseceni[n];
    for(int i=0;i<n;i++){
        poseceni[i]=false;
    }
    int mini,minj,minn = 2*n;
    for(int i=0;i<n;i++){
        for(int j = i+1;j<n;j++){
            bool moze = true;
            for(int k:graf[i]){
                if(k==j){
                    moze = false;
                    break;
                }
            }

            if(!moze){
                continue;
            }

            graf[i].push_back(j);
            graf[j].push_back(i);
            for(int k = 0;k<n;k++){
                int score = bfs(n,k,graf);
                if(score < minn){
                    minn = score;
                    mini = i;
                    minj = j;
                }
            }
            graf[i].pop_back();
            graf[j].pop_back();
        }
    }

    cout<<mini+1<<" "<<minj+1<<endl<<minn;
    return 0;
}