#include <bits/stdc++.h>
using namespace std;

const int N = 200000;
const int LOG = 18;

int par[N+5][LOG+1];
int depth[N+5];
vector <int> graf[N+5];

int in[N+5], out[N+5];
int niz[N+5];

int tjm;
int n;

struct Segment{
    int mn, mx, lazy;
} seg[4*N+5];

void propagate(int node, int l, int r){
    if(seg[node].lazy == 0) return;
    seg[node].mx += seg[node].lazy;
    seg[node].mn += seg[node].lazy;
    if(l == r){
        seg[node].lazy = 0;
        return;
    }
    seg[node*2].lazy += seg[node].lazy;
    seg[node*2+1].lazy += seg[node].lazy;
    seg[node].lazy = 0;
}

void init(int node, int l, int r){
    if(l == r){
        seg[node].mx = seg[node].mn = niz[l];
        seg[node].lazy = 0;
        return;
    }
    int mid = (l+r)/2;
    init(node*2, l, mid);
    init(node*2+1, mid+1, r);
    seg[node].mx = max(seg[node*2].mx, seg[node*2+1].mx);
    seg[node].mn = min(seg[node*2].mn, seg[node*2+1].mn);
}

void upd(int node, int l, int r, int tl, int tr, int d){
    propagate(node, l, r);
    if(tl > tr || tl > r || l > tr) return;
    if(tl <= l && r <= tr){
        seg[node].lazy += d;
        propagate(node, l, r);
        return;
    }
    int mid = (l+r)/2;
    upd(node*2, l, mid, tl, tr, d);
    upd(node*2+1, mid+1, r, tl, tr, d);
    seg[node].mx = max(seg[node*2].mx, seg[node*2+1].mx);
    seg[node].mn = min(seg[node*2].mn, seg[node*2+1].mn);
}

int posl_veci(int node, int l, int r, int tl, int tr, int h){
    propagate(node, l, r);
    if(tl > r || l > tr || tl > tr) return 0;
    if(l == r){
        if(seg[node].mx > h) return l;
        else return 0;
    }
    if(seg[node].mx <= h) return 0;
    int mid = (l+r)/2;
    int g = posl_veci(node*2+1, mid+1, r, tl, tr, h);
    if(g) return g;
    else return posl_veci(node*2, l, mid, tl, tr, h);
}

int prvi_veci(int node, int l, int r, int tl, int tr, int h){
    propagate(node, l, r);
    if(tl > r || l > tr || tl > tr) return 0;
    if(l == r){
        if(seg[node].mx > h) return l;
        else return 0;
    }
    if(seg[node].mx <= h) return 0;
    int mid = (l+r)/2;
    int g = prvi_veci(node*2, l, mid, tl, tr, h);
    if(g) return g;
    else return prvi_veci(node*2+1, mid+1, r, tl, tr, h);
}

int nz[N+5];

void dfs_sz(int v, int p){
    in[v] = ++tjm;
    depth[v] = depth[p] + 1;
    if(v == 1) depth[v] = 0;
    par[v][0] = p;
    for(int j=1; j<=LOG; j++) par[v][j] = par[par[v][j-1]][j-1];
    bool tt = 0;
    for(auto c : graf[v]){
        if(c == p) continue;
        tt = 1;
        dfs_sz(c, v);
    }
    niz[in[v]] = depth[v];
    nz[in[v]] = v;
    out[v] = tjm;
}

bool is_parent(int a, int b){
    return in[a] <= in[b] && in[b] <= out[a];
}

int lca(int a, int b){
    if(is_parent(a, b)) return a;
    for(int j=LOG; j>=0; j--) if(par[a][j] && !is_parent(par[a][j], b)) a = par[a][j];
    return par[a][0];
}

int dist(int a, int b){
    return depth[a] + depth[b] - 2*depth[lca(a, b)];
}

int res, mnv, mna, mnb;

int sa[N+5][LOG+1], sb[N+5][LOG+1];
int lg[N+5];

void merg(pair <int, int> &p, int d){
    if(p.first == 0){
        p.first = p.second = d;
        return;
    }
    if(d == 0) return;
    int x = p.first, y = p.second;
    int da = dist(x, d);
    int db = dist(y, d);
    int dc = dist(x, y);
    if(da >= db && da >= dc){
        p.first = x;
        p.second = d;
    }
    else if(db >= da && db >= dc){
        p.first = y;
        p.second = d;
    }
    else{
        p.first = x;
        p.second = y;
    }
}

pair <int, int> squery(int l, int r){
    if(l == 0 || r == 0) return {0, 0};
    int h = lg[r - l + 1];
    pair <int, int> ra = {sa[l][h], sb[l][h]};
    merg(ra, sa[r - (1 << h) + 1][h]);
    merg(ra, sb[r - (1 << h) + 1][h]);
    return ra;
}

bool pokusaj(int v){
    int a1 = prvi_veci(1, 1, n, 1, in[v] - 1, res - 1);
    int a2 = posl_veci(1, 1, n, 1, in[v] - 1, res - 1);
    int b1 = prvi_veci(1, 1, n, in[v], out[v], res - 1);
    int b2 = posl_veci(1, 1, n, in[v], out[v], res - 1);
    int c1 = prvi_veci(1, 1, n, out[v] + 1, n, res - 1);
    int c2 = posl_veci(1, 1, n, out[v] + 1, n, res - 1);
    pair <int, int> a = squery(a1, a2);
    pair <int, int> b = squery(b1, b2);
    pair <int, int> c = squery(c1, c2);
    pair <int, int> rds = a;
    merg(rds, b.first);
    merg(rds, b.second);
    merg(rds, c.first);
    merg(rds, c.second);
    if((1 + (dist(rds.first, rds.second) + 1)/2) <= res - 1){
        mnv = v;
        mna = rds.first;
        mnb = rds.second;
        return 1;
    }
    return 0;
}

void dfs(int v, int p){
    while(res > 1 && pokusaj(v)){
        res--;
    }
    for(auto c : graf[v]){
        if(c == p) continue;
        upd(1, 1, n, 1, n, 1);
        upd(1, 1, n, in[c], out[c], -2);
        dfs(c, v);
        upd(1, 1, n, in[c], out[c], 2);
        upd(1, 1, n, 1, n, -1);
    }
}

void nadji(){
    if(graf[n].size() == n - 1){
        cout << "1 2\n";
        return;
    }
    for(int i=1; i<n; i++){
        bool d = 1;
        for(auto c : graf[i]){
            if(c == n) d = 0;
        }
        if(d){
            cout << i << " " << n << "\n";
            return;
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    cin >> n;
    res = n, mnv = 1, mna = 1, mnb = 1;
    for(int i=2; i<=N; i++) lg[i] = lg[i/2] + 1;
    for(int i=1; i<n; i++){
        int a, b;
        cin >> a >> b;
        graf[a].push_back(b);
        graf[b].push_back(a);
    }
    dfs_sz(1, 0);
    init(1, 1, n);
    for(int i=1; i<=n; i++) sa[i][0] = sb[i][0] = nz[i];
    for(int j=1; j<=LOG; j++){
        for(int i=1; i+(1<<j)-1<=n; i++){
            pair <int, int> rda = {sa[i][j-1], sb[i][j-1]};
            pair <int, int> rdb = {sa[i + (1<<(j-1))][j-1], sb[i + (1<<(j-1))][j-1]};
            merg(rda, rdb.first);
            merg(rda, rdb.second);
            sa[i][j] = rda.first;
            sb[i][j] = rda.second;
        }
    }
    dfs(1, 0);
    int trb = 1;
    for(int i=1; i<=n; i++){
        int t1 = dist(mna, i);
        int t2 = dist(mnb, i);
        if(abs(t1 - t2) <= 1 && t1 + t2 == dist(mna, mnb)) trb = i;
    }
    bool moze = 1;
    for(auto c : graf[mnv]){
        if(c == trb) moze = 0;
    }
    if(mnv == trb) moze = 0;
    if(!moze) nadji();
    else cout << mnv << " " << trb << "\n";
    cout << mnv << "\n";
    return 0;
}