#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long

using namespace std;

ll memo[200][200];

ll brute(vector<vector<ll>>& a, vector<ll>& s, ll& n, ll& m, int k, int dep)
{
    if(k == 0 || dep == n)
    {
        return 0;
    }
    if(memo[k][dep] != -1) return memo[k][dep];
    ll sum = 0;
    for(int i=0;i<=k;i++){
        int upnd = lower_bound(a[dep].begin(), a[dep].end(), i) - a[dep].begin();
        sum = max(brute(a,s,n,m,k-i,dep+1) + s[dep]*upnd, sum);
    }
    memo[k][dep] = sum;
    return sum;
}

void solve()
{
    for(int i=0;i<200;i++){
        for(int j=0;j<200;j++){
            memo[i][j] = -1;
        }
    }
    ll n, m, k; cin >> n >> m >> k;
    vector<ll> s(n); for(auto& i : s) cin >> i;
    vector<vector<ll>> a(n, vector<ll>(m));
    for(auto& i : a){
        for(auto& j : i) cin >> j;
        sort(i.begin(), i.end());
    }
    if(n == 1) {
        int br = 0;
        for(int i=0; i < m; i++) br += k > a[0][i];
        cout << s[0] * br << endl;
        return;
    }
    if(n <= 6 && k <= 6)
    {
        cout << brute(a, s, n, m, k, 0) << endl;
        return;
    }
    if(n <= 200 && m <= 200 && k <= 200)
    {
        cout << brute(a, s, n, m, k, 0) << endl;
        return;
    }
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    solve();
    return 0;
}