#include <bits/stdc++.h>
using namespace std;

const long long N = 200005;

pair<long long, long long> dot[N];
long long xComp[N]; //compressed x value of i-th dot
long long yComp[N];
long long xBack[N]; //index of dot that has compressed value i
long long yBack[N]; //index of dot has compressed value i
long long n;

void compression(){
    vector<pair<pair<long long, bool>, long long>> allVals; //koord value; x = true, y = false; index of dot

    for(long long i = 0; i < n; ++i){
        allVals.push_back({{dot[i].first, true}, i});
        allVals.push_back({{dot[i].second, false}, i});
    }

    sort(allVals.begin(), allVals.end());
    long long compCounter = 0;
    for(long long i = 0; i < (long long)(allVals.size()); ++i){
        if(i == 0 || allVals[i].first.first != allVals[i - 1].first.first){
            compCounter++;
        }
        if(allVals[i].first.second){ //x
            xComp[allVals[i].second] = compCounter;
            xBack[compCounter] = allVals[i].second;
        }else{ //y
            yComp[allVals[i].second] = compCounter;
            yBack[compCounter] = allVals[i].second;
        }
    }

}

long long adx[2 * N];
long long ady[2 * N];
long long st1[8 * N];
long long st2[8 * N];


void update1(long long ind, long long id, long long l, long long r){
    if(ind > r || ind < l)
        return;
    if(l == r){
        st1[id]++;
        return;
    }

    long long mid = (l + r) / 2;
    update1(ind, id * 2 + 1, l, mid);
    update1(ind, id * 2 + 2, mid + 1, r);
    st1[id] = st1[id * 2 + 1] + st1[id * 2 + 2];
}

void update2(long long ind, long long id, long long l, long long r){
    if(ind > r || ind < l)
        return;
    if(l == r){
        st2[id]++;
        return;
    }

    long long mid = (l + r) / 2;
    update2(ind, id * 2 + 1, l, mid);
    update2(ind, id * 2 + 2, mid + 1, r);
    st2[id] = st2[id * 2 + 1] + st2[id * 2 + 2];
}

long long getSum(long long tree, long long x, long long y, long long id, long long l, long long r){
    if(x > r || y < l)
        return 0;
    if(x <= l && r <= y){
        if(tree == 1)
            return st1[id];
        else
            return st2[id];
    }

    long long mid = (l + r) / 2;
    long long v1 = getSum(tree, x, y, id * 2 + 1, l, mid);
    long long v2 = getSum(tree, x, y, id * 2 + 2, mid + 1, r);
    return v1 + v2;
}

long long findMid(long long tree){
    long long total = (tree == 1 ? st1[0] : st2[0]);
    long long need = total / 2 + 1;

    long long l = 0, r = 2 * n;
    long long mid;
    while(l <= r){
        mid = (l + r) / 2;
        long long v = getSum(tree, 0, mid, 0, 0, 2 * n);
        if(v == need){
            r = mid;
            long long v2 = getSum(tree, 0, mid - 1, 0, 0, 2 * n);
            if(v2 < v){
                return mid;
            }
        }else if(v > need){
            r = mid - 1;
        }else{
            l = mid + 1;
        }
    }

    return mid;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    for(long long i = 0; i < n; ++i){ ///take care of index
        cin >> dot[i].first >> dot[i].second;
    }

    compression();

    for(long long i = 0; i < n; ++i){
        update1(xComp[i], 0, 0, 2 * n);
        update2(yComp[i], 0, 0, 2 * n);

        if((i + 1) % 2 == 0){
            cout << "-1\n";
            continue;
        }

        long long mdx = findMid(1);
        long long mdy = findMid(2);

        if(xBack[mdx] == yBack[mdy]){
            cout << xBack[mdx] + 1 << "\n";
        }else{
            cout << "-1\n";
        }
    }

    return 0;
}