#include <bits/stdc++.h>
using namespace std;

const int N = 200005;

pair<int, int> dot[N];
int xComp[N]; //compressed x value of i-th dot
int yComp[N];
int xBack[N]; //index of dot that has compressed value i
int yBack[N]; //index of dot has compressed value i
int n;

void compression(){
    vector<pair<pair<int, bool>, int>> allVals; //koord value; x = true, y = false; index of dot

    for(int i = 0; i < n; ++i){
        allVals.push_back({{dot[i].first, true}, i});
        allVals.push_back({{dot[i].second, false}, i});
    }

    sort(allVals.begin(), allVals.end());
    int compCounter = 0;
    for(int i = 0; i < (int)(allVals.size()); ++i){
        if(i == 0 || allVals[i].first.first != allVals[i - 1].first.first){
            compCounter++;
        }
        if(allVals[i].first.second){ //x
            xComp[allVals[i].second] = compCounter;
            xBack[compCounter] = allVals[i].second;
        }else{ //y
            yComp[allVals[i].second] = compCounter;
            yBack[compCounter] = allVals[i].second;
        }
    }

}

void printCompression(){
    for(int i = 0; i < n; ++i){
        cout << xComp[i] << " " << yComp[i] << "\n";
    }
}

int adx[2 * N];
int ady[2 * N];
int st[3][8 * N];


void update(int tree, int ind, int id, int l, int r){
    if(ind > r || ind < l)
        return;
    if(l == r){
        st[tree][id]++;
        return;
    }

    int mid = (l + r) / 2;
    update(tree, ind, id * 2 + 1, l, mid);
    update(tree, ind, id * 2 + 2, mid + 1, r);
    st[tree][id] = st[tree][id * 2 + 1] + st[tree][id * 2 + 2];
}


int getSum(int tree, int x, int y, int id, int l, int r){
    if(x > r || y < l)
        return 0;
    if(x <= l && r <= y){
        return st[tree][id];
    }

    int mid = (l + r) / 2;
    int v1 = getSum(tree, x, y, id * 2 + 1, l, mid);
    int v2 = getSum(tree, x, y, id * 2 + 2, mid + 1, r);
    return v1 + v2;
}

int findMid(int tree, int need, int id, int l, int r){
    if(l == r && need == 1 && st[tree][id] == 1){
        return l;
    }

    if(st[tree][id * 2 + 1] < need){
        return findMid(tree, need - st[tree][id * 2 + 1], id * 2 + 2, (l + r) / 2 + 1, r);
    }else{
        return findMid(tree, need, id * 2 + 1, l, (l + r) / 2);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    for(int i = 0; i < n; ++i){ ///take care of index
        cin >> dot[i].first >> dot[i].second;
    }

    compression();

    for(int i = 0; i < n; ++i){
        update(1, xComp[i], 0, 0, 2 * n);
        update(2, yComp[i], 0, 0, 2 * n);

        if((i + 1) % 2 == 0){
            cout << "-1\n";
            continue;
        }

        int mdx = findMid(1, (i + 1) / 2 + 1, 0, 0, 2 * n);
        int mdy = findMid(2, (i + 1) / 2 + 1, 0, 0, 2 * n);

        if(xBack[mdx] == yBack[mdy]){
            cout << xBack[mdx] + 1 << "\n";
        }else{
            cout << "-1\n";
        }
    }

    return 0;
}

/*
int findMid(int tree){
    int total = (tree == 1 ? st1[0] : st2[0]);
    int need = total / 2 + 1;

    int l = 0, r = 2 * n;
    int mid;
    while(1){
        mid = (l + r) / 2;
        int v = getSum(tree, 0, mid, 0, 0, 2 * n);

        if(v == need){
            int v2 = getSum(tree, 0, mid - 1, 0, 0, 2 * n);
            if(v2 < v)
                return mid; //always gets to this

            r = mid - 1;
        }else if(v > need){
            r = mid - 1;
        }else{
            l = mid + 1;
        }
    }

    while(1);
}
*/