#include <bits/stdc++.h>

using namespace std;

const int N = 200000;
const int M = 4 * N;

namespace sX {
  int st[M];
  void modify(int node, int l, int r, int x, int v) {
    st[node] += v;
    if (l == r) return;
    int mid = l + r >> 1;
    if (x <= mid) {
      modify(node + node, l, mid, x, v);
    } else {
      modify(node + node + 1, mid + 1, r, x, v);
    }
  }
  int walk(int node, int l, int r, int x) {
    if (l == r) {
      return l;
    }
    int mid = l + r >> 1;
    if (st[node + node] >= x) {
      return walk(node + node, l, mid, x);
    } else {
      return walk(node + node + 1, mid + 1, r, x - st[node + node]);
    }
  }
};

namespace sY {
  int st[M];
  void modify(int node, int l, int r, int x, int v) {
    st[node] += v;
    if (l == r) return;
    int mid = l + r >> 1;
    if (x <= mid) {
      modify(node + node, l, mid, x, v);
    } else {
      modify(node + node + 1, mid + 1, r, x, v);
    }
  }
  int walk(int node, int l, int r, int x) {
    if (l == r) {
      return l;
    }
    int mid = l + r >> 1;
    if (st[node + node] >= x) {
      return walk(node + node, l, mid, x);
    } else {
      return walk(node + node + 1, mid + 1, r, x - st[node + node]);
    }
  }
};

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> x(n), y(n);
  for (int i = 0; i < n; i++) {
    cin >> x[i] >> y[i];
  }
  vector<int> cx;
  vector<int> cy;
  for (int i = 0; i < n; i++) {
    cx.push_back(x[i]);
    cy.push_back(y[i]);
  }
  sort(cx.begin(), cx.end());
  sort(cy.begin(), cy.end());
  cx.erase(unique(cx.begin(), cx.end()), cx.end());
  cy.erase(unique(cy.begin(), cy.end()), cy.end());
  for (int i = 0; i < n; i++) {
    x[i] = lower_bound(cx.begin(), cx.end(), x[i]) - cx.begin();
    y[i] = lower_bound(cy.begin(), cy.end(), y[i]) - cy.begin();
  }
  map<int, int> mpX;
  map<int, int> mpY;
  for (int i = 0; i < n; i++) {
    mpX[x[i]] = i;
    mpY[y[i]] = i;
  }
  for (int i = 0; i < n; i++) {
    sX::modify(1, 0, cx.size(), x[i], 1);
    sY::modify(1, 0, cy.size(), y[i], 1);
    if (i % 2 == 1) {
      cout << -1 << '\n';
      continue;
    }
    int idX = sX::walk(1, 0, cx.size() - 1, i / 2 + 1);
    int idY = sY::walk(1, 0, cy.size() - 1, i / 2 + 1);
    if (mpX[idX] == mpY[idY]) {
      cout << idX + 1 << '\n';
    } else {
      cout << -1 << '\n';
    }
    /*int mx, my;
    cin >> mx >> my;
    x.push_back(mx);
    y.push_back(my);
    vector<int> order(i + 1);
    iota(order.begin(), order.end(), 0);
    sort(order.begin(), order.end(), [&](int i, int j) {
      return x[i] < x[j];
    });
    vector<int> cands;
    if (i % 2 == 0) {
      cands.push_back(order[i / 2]);
    }
    if (i % 2 == 1) {
      cout << -1 << '\n';
      continue;
    }
    int ans = -1;
    for (int i : cands) {
      vector<int> cnt(4);
      for (int j = 0; j < x.size(); j++) {
        if (i == j) {
          continue;
        }
        if (x[j] < x[i]) {
          if (y[j] < y[i]) {
            cnt[0] += 1;
          } else {
            cnt[2] += 1;
          }
        } else {
          if (y[i] < y[j]) {
            cnt[1] += 1;
          } else {
            cnt[3] += 1;
          }
        }
      }
      if (cnt[0] == cnt[1] && cnt[2] == cnt[3]) {
        ans = i + 1;
      }
    }
    cout << ans << '\n';*/
  }
  return 0;
}