#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> u(n);
  vector<int> v(n);
  vector<vector<int>> g(n);
  map<pair<int, int>, bool> have;
  for (int i = 1; i < n; i++) {
    cin >> u[i] >> v[i];
    --u[i]; --v[i];
    have[{u[i], v[i]}] = true;
    have[{v[i], u[i]}] = true;
    g[u[i]].push_back(v[i]);
    g[v[i]].push_back(u[i]);
  }
  for (int i = 0; i < n; i++) {
    if (g[i].size() == n - 1) {
      cout << g[i][0] + 1 << " " << g[i][1] + 1 << '\n';
      cout << i + 1 << '\n';
      return 0;
    }
  }
  int du = -1, dv = -1;
  auto Bfs = [&](int u) {
    vector<int> dist(n, -1);
    dist[u] = 0;
    vector<int> que;
    que.push_back(u);
    for (int b = 0; b < que.size(); b++) {
      int p = que[b];
      for (int v : g[p]) {
        if (dist[v] == -1) {
          dist[v] = dist[p] + 1;
          que.push_back(v);
        }
      }
    }
    int who = 0;
    for (int i = 0; i < n; i++) {
      if (dist[i] > dist[who]) {
        who = i;
      }
    }
    return who;
  };
  du = Bfs(0);
  dv = Bfs(du);
  int cen = -1;
  vector<int> par(n), dep(n);
  vector<int> tin(n), tout(n);
  int T = 0;
  const int LOG = 25;
  vector<vector<int>> up(n, vector<int>(LOG));
  function<void(int, int)> Dfs = [&](int u, int p) {
    tin[u] = ++T;
    up[u][0] = p;
    for (int i = 1; i < LOG; i++) {
      up[u][i] = up[up[u][i - 1]][i - 1];
    }
    par[u] = p;
    dep[u] = dep[p] + 1;
    for (int v : g[u]) {
      if (v == p) {
        continue;
      }
      Dfs(v, u);
    }
    tout[u] = ++T;
  };
  auto is_anc = [&](int x, int y) {
    return tin[x] <= tin[y] && tout[y] <= tout[x];
  };
  auto Lca = [&](int x, int y) {
    if (is_anc(x, y)) return x;
    if (is_anc(y, x)) return y;
    for (int i = LOG - 1; i >= 0; i--) {
      if (!is_anc(up[x][i], y)) {
        x = up[x][i];
      }
    }
    return up[x][0];
  };
  Dfs(0, 0);
  vector<int> path;
  vector<int> pX;
  vector<int> pY;
  int l = Lca(du, dv);
  //cout << du << " " << dv << endl;
  while (du != l) {
    pX.push_back(du);
    du = par[du];
  }
  pX.push_back(du);
  while (dv != l) {
    pY.push_back(dv);
    dv = par[dv];
  }
  for (int id : pX) path.push_back(id);
  reverse(pY.begin(), pY.end());
  for (int id : pY) path.push_back(id);
  int x = -1, y = -1, ans = 1e9;
  vector<vector<int>> ng(n);
  for (int i = 1; i < n; i++) {
    ng[u[i]].push_back(v[i]);
    ng[v[i]].push_back(u[i]);
  }
  function<void(int, int)> Try = [&](int ww, int www) {
    if (ww == www || have[{ww, www}]) {
      return;
    }
    ng[ww].push_back(www);
    ng[www].push_back(ww);
    vector<int> que(1, ww);
    vector<int> dist(n, -1);
    int mx = 0;
    for (int b = 0; b < que.size(); b++) {
      int p = que[b];
      mx = max(mx, dist[p]);
      for (int q : ng[p]) {
        if (dist[q] == -1) {
          dist[q] = dist[p] + 1;
          que.push_back(q);
        }
      }
    }
    ng[ww].pop_back();
    ng[www].pop_back();
    if (mx < ans) {
      ans = mx;
      x = ww;
      y = www;
    }
  };
  int sz = path.size();
  auto Check = [&](int x) {
    if (x == sz - 1) {
      Try(path[0], path.back());
      return true;
    }
    for (int st : {x, sz - x - 1, sz / 2}) {
      Try(path[st], path[min(sz - 1, st + 2 * x)]);
      Try(path[st], path[sz - x - 1]);
      Try(path[st], path[max(0, st - 2 * x)]);
    }
    return ans <= x;
  };
  int low = 1, high = sz - 1;
  while (low <= high) {
    int mid = low + high >> 1;
    if (Check(mid)) {
      high = mid - 1;
    } else {
      low = mid + 1;
    }
  }
  cout << x + 1 << " " << y + 1 << '\n';
  cout << x + 1 << '\n';
  return 0;
}