#include <iostream>
#include <cmath>
#include <vector>
#include <climits>

using namespace std;

vector<int> graf[200001];
vector<bool> visited;

int dfsmax(int v, int n, int d)
{
    visited[v] = true;
    int res = 0;

    for(int i = 0; i < graf[v].size(); i++)
    {
        if(!visited[graf[v][i]])
            res = max(res, dfsmax(i, n, d+1));
    }

    return d;
}

int main(void)
{
    ios::sync_with_stdio(false);

    int n, u, v;

    cin >> n;
    for(int i = 0; i < n-1; i++)
    {
        cin >> u >> v;
        graf[u].push_back(v);
        graf[v].push_back(u);
    }

    int dmax = INT_MAX;
    int swap1, swap2;

    for(int i = 0; i < n; i++)
    {
        for(int j = i+1; j < n; j++)
        {
            graf[i].push_back(j);
            graf[j].push_back(i);

            visited.assign(n+1, false);
            int dmaxi = dfsmax(i, n, 0);
            visited.assign(n+1, false);
            int dmaxj = dfsmax(j, n, 0);

            if(dmaxi < dmaxj && dmaxi < dmax)
            {
                swap1 = i;
                swap2 = j;
            }
            else if(dmaxj < dmaxi && dmaxj < dmax)
            {
                swap1 = j;
                swap2 = i;
            }

            graf[i].pop_back();
            graf[j].pop_back();
        }
    }

    cout << swap1 << swap2 << "\n";
    cout << swap1 << "\n";

    return 0;
}