#include <iostream>
#include <cmath>
#include <vector>
#include <climits>

using namespace std;

vector<int> graf[200002];
vector<bool> visited;
int maxdist[200002];
int maxind[200002];

void dfsmax(int v, int n, int d, int s)
{
    visited[v] = true;

    for(int i = 0; i < graf[v].size(); i++)
    {
        if(!visited[graf[v][i]])
            dfsmax(graf[v][i], n, d+1, s);
    }

    if(d > maxdist[s])
    {
        maxdist[s] = d;
        maxind[s] = v;
    }
}

int main(void)
{
    ios::sync_with_stdio(false);

    int n, u, v;

    cin >> n;
    for(int i = 0; i < n-1; i++)
    {
        cin >> u >> v;
        graf[u].push_back(v);
        graf[v].push_back(u);
    }

    visited.assign(n, false);
    for(int i = 1; i <= n; i++)
        dfsmax(i, n, 0, i);

    int dmax = -1, dmaxind = -1;

    for(int i = 1; i <= n; i++)
    {
        if(maxdist[i] > dmax)
        {
            dmax = maxdist[i];
            dmaxind = i;
        }
    }

    cout << dmaxind << " " << maxind[dmaxind] << "\n";
    cout << dmaxind << "\n";

    return 0;
}