#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#define ll long long
#define ull unsigned ll

using namespace std;

struct rainRange {
    int l;
    int r;
};

struct target {
    int index;
    ll diff;
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    vector<int> capacities(n + 1);

    int i;
    int j;
    for(i = 1; i <= n; i++)
        cin >> capacities[i];

    vector<vector<int> > whichHit(n + 1);
    vector<rainRange> rainyDays(m);
    for(i = 0; i < m; i++) {
        cin >> rainyDays[i].l >> rainyDays[i].r;
        for(j = rainyDays[i].l; j <= rainyDays[i].r; j++)
            whichHit[j].push_back(i);
    }

    ll total = 0;
    ll diff;

    vector<ll> tmpmap(m);
    for(i = 1; i <= n; i++) {
        diff = capacities[i] - whichHit[i].size();
        if(diff < 0) {
            total -= diff;
            for(j = 0; j < whichHit[i].size(); j++)
                tmpmap[whichHit[i][j]]++;
        }
    }

    sort(tmpmap.begin(), tmpmap.end(), greater<ll>());
    i = 0;
    while(i < m && total > 0) {
        total -= tmpmap[i];
        i++;
    }

    cout << i + 1;

    return EXIT_SUCCESS;
}