#include <bits/stdc++.h>

#define ll long long
#define MAX 2010

using namespace std;

const ll mod = 1e9 + 7;

ll add(ll a, ll b) {

    a += b;
    if(a >= mod)
        a -= mod;
    return a;
}

ll sub(ll a, ll b) {

    a -= b;
    if(a < 0)
        a += mod;
    return a;
}

ll dp[MAX][MAX];
int mat[MAX][MAX], pre[MAX][MAX], id[MAX][MAX], indx1[MAX][MAX], indx2[MAX][MAX];

int bs1(int i, int j, int n, int m, int k) {

    int l = j, r = m;
    while(l <= r) {
        int mid = (l + r) / 2;
        int x = pre[i][mid - 1] - pre[i][j - 1];
        int y = pre[i][j - 1] - (k - x);
        if(k >= x && pre[i][mid - 1] < j && (y < 0 || id[i][y] < j - k))
            l = mid + 1;
        else
            r = mid - 1;
    }
    return l - 1;
}

int bs2(int i, int j, int n, int m, int k) {

    int l = 1, r = j;
    while(l <= r) {
        int mid = (l + r) / 2;
        int x = pre[i][j] - pre[i][mid];
        int y = pre[i][j] + (k - x) + 1;
        if(k >= x && pre[i][m] - pre[i][mid] <= m - j && (y > pre[i][m] || id[i][y] > j + k))
            r = mid - 1;
        else
            l = mid + 1;
    }
    return r + 1;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            char c;
            cin >> c;
            if(c == '0')
                mat[n - i - 1][m - j - 1] = 0;
            else
                mat[n - i - 1][m - j - 1] = 1;
        }
    }
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            pre[i + 1][j + 1] = pre[i + 1][j] + mat[i][j];
            if(mat[i][j])
                id[i + 1][pre[i + 1][j + 1]] = j + 1;
        }
    }

    for(int i = 1; i <= n; i++) {
        for(int j = 1; j <= m; j++) {
            indx1[i][j] = bs1(i, j, n, m, k);
            indx2[i][j] = bs2(i, j, n, m, k);
        }
    }

    for(int j = 1; j <= m; j++)
        dp[0][j] = 1;
    for(int i = 1; i <= n; i++) {
        ll pref[m + 1];
        pref[0] = 0;
        for(int j = 1; j <= m; j++) {
            ll x = dp[i - 1][j];
            if(mat[i - 1][j - 1])
                x = 0;
            pref[j] = add(pref[j - 1], x);
        }
        if(i == n) {
            cout << pref[m] << endl;
            return 0;
        }
        for(int j = 1; j <= m; j++)
            dp[i][j] = sub(pref[indx1[i][j]], pref[indx2[i][j] - 1]);
    }
    return 0;
}