#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define MAXN 200010

using namespace std;

vector<int> graph[MAXN];
ll dist[MAXN];

void bfs(int src) {

    queue<int> q;
    q.push(src);
    dist[src] = 0;
    while(!q.empty()) {
        int u = q.front();
        q.pop();

        for(int v: graph[u]) {
            if(dist[v] == -1) {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
        }
    }
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    for(int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;

        graph[u].pb(v);
        graph[v].pb(u);
    }

    ll best = LLONG_MAX;
    int ansu = -1, ansv = -1;
    for(int u = 0; u < n; u++) {
        for(int v = 0; v < n; v++) {
            graph[u].pb(v);
            for(int i = 0; i < n; i++)
                dist[i] = -1;
            bfs(u);
            graph[u].pop_back();

            ll sum = 0;
            for(int i = 0; i < n; i++)
                sum += dist[i];
            if(sum < best) {
                best = sum;
                ansu = u;
                ansv = v;
            }
        }
    }

    if(ansu == ansv)
        ansv = (ansv + 1) % n;
    cout << ansu + 1 << " " << ansv + 1 << endl << ansu + 1 << endl;
    return 0;
}