#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define MAXN 200010
#define MAX 410

using namespace std;

vector<int> graph[MAXN];
bool g[MAX][MAX];
ll dist[MAXN];

bool cmp(int a, int b) {

    return dist[a] > dist[b];
}

int parent[MAXN], dt[MAXN], ft[MAXN], t = 0;

void dfs(int u, int p) {

    if(p != -1)
        dist[u] = dist[p] + 1;
    parent[u] = p;
    dt[u] = t++;
    for(int v: graph[u])
        if(v != p)
            dfs(v, u);
    ft[u] = t++;
}

int lcs(int u, int p, int a, int b) {

    for(int v: graph[u])
        if(v != p && dt[v] <= dt[a] && ft[a] <= ft[v] && dt[v] <= dt[b] && ft[b] <= ft[v])
            return lcs(v, u, a, b);
    return u;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    for(int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;

        graph[u].pb(v);
        graph[v].pb(u);
        g[u][v] = g[v][u] = true;
    }

    int temp1 = -1, temp2 = -1;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            if(i != j && !g[i][j]) {
                temp1 = i;
                temp2 = j;
                break;
            }
        }
        if(temp1 != -1)
            break;
    }

    int a[n];
    for(int i = 0; i < n; i++)
        a[i] = i;

    ll best = LLONG_MAX;
    int ansu, ansv, anssrc;
    for(int u = 0; u < n; u++) {
        for(int i = 0; i < n; i++)
            dist[i] = -1;
        dfs(u, -1);

        sort(a, a + n, cmp);
        int l = a[0], new_l;
        for(int i = 1; i < n; i++) {
            new_l = lcs(u, -1, l, a[i]);
            if(g[new_l][u])
                break;
        }

        if(dist[new_l] < best) {
            best = dist[new_l];
            anssrc = u;
            ansu = u;
            ansv = l;

            if(g[l][u]) {
                ansu = temp1;
                ansv = temp2;
            }
        }
    }

    cout << ansu + 1 << " " << ansv + 1 << endl << anssrc + 1 << endl;
    return 0;
}