#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pdd;

#define ff(i,a,b) for(int i = a; i <= b; i++)
#define fb(i,b,a) for(int i = b; i >= a; i--)
#define trav(a,x) for (auto& a : x)

#define sz(a) (int)(a).size()
#define pb push_back
#define fi first
#define se second
#define lb lower_bound
#define ub upper_bound
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) the number of elements in the os less than k
// *os.find_by_order(k)  print the k-th smallest number in os(0-based)

const int mod = 1000000007;
const int inf = 1e9 + 5;
const int mxN = 2005;

int n, m, k;
string s[mxN];

int dp[mxN][mxN]; // broj nacina da stignem u polje (i, j)

int add(int a, int b){
    a += b;
    if(a >= mod)a -= mod;
    return a;
}
int sub(int a, int b){
    a -= b;
    if(a < 0)a += mod;
    return a;
}
int mul(int a, int b){
    return (1ll * a * b) % mod;
}

int A[mxN][mxN];
int pref[mxN];
void Solve(int i){
    ff(j,1,m)if(s[i][j] == '0')dp[i][j] = dp[i + 1][j];

    ff(j,1,m)pref[j] = pref[j - 1] + (s[i][j] == '1');

//    cout << "i: " << i << endl;

    if(i == 1)return;
    ff(j,1,m){
        if(s[i][j] == '1')continue;

        int l = j + 1, r = m, ans = j;
        while(l <= r){
            int mid = (l + r) / 2;
            if(pref[mid] - pref[j] <= k){
                ans = mid;
                l = mid + 1;
            }
            else r = mid - 1;
        }

//        cout << "ans: " << ans << endl;

        int br = pref[ans] - pref[j];
        int poz = ans;

        int L = j + 1;
        int R = poz - br;

        if(L <= R){
            A[i][L] = add(A[i][L], dp[i][j]);
            A[i][R + 1] = sub(A[i][R + 1], dp[i][j]);
        }

//
//        cout << "j: " << j << endl;
//        cout << "br: " << br << endl;
//        cout << "poz: " << poz << endl;
//        cout << "range: " << j + 1 << " " << poz - br << '\n';
//        cout << endl;


//        ff(l,j + 1,poz - br){
//            A[i][l] = add(A[i][l], dp[i][j]);
//        }

    }
//
//    cout << "A1: " << endl;
//    ff(j,1,m)cout << A[i][j] << " ";
//    cout << endl;

    fb(j,m,1){
        if(s[i][j] == '1')continue;
//
//        int br = 0, poz = 1;
//        fb(l,j - 1,1){
//            br += (s[i][l] == '1');
//            if(br > k){
//                poz = l + 1; br -= 1;
//                break;
//            }
//        }

        int l = 1, r = j - 1, ans = j;
        while(l <= r){
            int mid = (l + r) / 2;
            if(pref[j] - pref[mid - 1] <= k){
                ans = mid;
                r = mid - 1;
            }
            else l = mid + 1;
        }

        int br = pref[j] - pref[ans - 1];
        int poz = ans;

//        cout << "j: " << j << endl;
//        cout << "poz: " << poz << endl;
//        cout << "range: " << j - 1 << " " << poz + br << '\n';
//        cout << endl;

        int L = poz + br;
        int R = j - 1;

        if(L <= R){
            A[i][L] = add(A[i][L], dp[i][j]);
            A[i][R + 1] = sub(A[i][R + 1], dp[i][j]);
        }

//        fb(l,j - 1,poz + br){
//            A[i][l] = add(A[i][l], dp[i][j]);
//        }
    }

//
//    cout << "A2: " << endl;
//    ff(j,1,m)cout << A[i][j] << " ";
//    cout << endl;

//

    ff(j,1,m)A[i][j] = add(A[i][j], A[i][j - 1]);

    ff(j,1,m)dp[i][j] = add(dp[i][j], A[i][j]);
//
//    cout << "-------------------------" << endl;
//    cout << endl;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    cin >> n >> m >> k;
    ff(i,1,n)cin >> s[i], s[i] = ' ' + s[i];

    ff(i,1,m)if(s[n][i] == '0')dp[n + 1][i] = 1;

    fb(i,n,1)Solve(i);

    int rez = 0;
    ff(j,1,m)rez = add(rez, dp[1][j]);
////
//    cout << endl;
//    ff(i,1,n){
//        ff(j,1,m)cout << dp[i][j] << " ";
//        cout << '\n';
//    }

    cout << rez << '\n';

    return 0;
}
/*

2 2 0
00
00

2 4 0
0000
0000

2 12 0
000000000000
111100001111

3 9 3
010001100
101011010
011101110

// probati bojenje sahovski
*/