#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pdd;

#define ff(i,a,b) for(int i = a; i <= b; i++)
#define fb(i,b,a) for(int i = b; i >= a; i--)
#define trav(a,x) for (auto& a : x)

#define sz(a) (int)(a).size()
#define pb push_back
#define fi first
#define se second
#define lb lower_bound
#define ub upper_bound
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) the number of elements in the os less than k
// *os.find_by_order(k)  print the k-th smallest number in os(0-based)

const int mod = 1000000007;
const int inf = 1e9 + 5;
const int mxN = 200005;

int n;

vector<int> g[mxN];
bool bio[mxN];

int d[mxN];
void dfs1(int v, int p){
    for(auto u : g[v]){
        if(u != p){
            d[u] = d[v] + 1;
            dfs1(u, v);
        }
    }
}

int mx = 0;

int par[mxN];
int dist[mxN];
void dfs2(int v, int p){
    par[v] = p;
    for(auto u : g[v]){
        if(u != p){
            dist[u] = dist[v] + 1;
            dfs2(u, v);
        }
    }
}

pii res[mxN];
bool check(int X, int root){
    if(d[mx] <= X){
        // mora izmedju kojih nema linija
        res[root] = {0, 0};
        return 1;
    }

    // jedan kraj diametra je mx

    int dia = 0;
    ff(i,1,n){
        if(d[i] > X){
            if(dist[dia] < dist[i]){
                dia = i;
            }
        }
    }

    int R = (dist[dia] + 1) / 2;

    if(R + 1 <= X){

        int Z = 0;
        for(int A = dia; A != -1 && R > 0; A = par[A]){
            Z = A; R -= 1;
        }

        res[root] = {Z, root};

        return 1;
        // ovo moze da bude resenje

    }
    else return 0;

}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    // da li je root uvek sredina diametra

    cin >> n;
    ff(i,1,n - 1){
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }

    int rez = inf;
    int ko = 0;
    ff(root,1,n){
        // ovo ce da bude root

        d[root] = 0; dfs1(root, -1);

        mx = 0;
        ff(i,1,n)if(d[mx] < d[i])mx = i;

        dist[mx] = 0; dfs2(mx, -1);

        int l = 0, r = n, ans = 0;
        while(l <= r){
            int mid = (l + r) / 2;
            if(check(mid, root)){
                ans = mid;
                r = mid - 1;
            }
            else l = mid + 1;
        }

        if(rez > ans){
            rez = ans;
            ko = root;
        }

    }

    pii edge = res[ko];

    if(edge.fi == 0){

        ff(i,1,n){
            if(sz(g[i]) != n - 1){

                for(auto c : g[i]){
                    bio[c] = 1;
                }

                ff(j,1,n){
                    if(i != j && bio[j] == 0){
                        edge = {i, j};
                        break;
                    }
                }

            }

            if(edge.fi != 0){
                break;
            }

        }

    }

    cout << edge.fi << " " << edge.se << '\n';
    cout << ko << '\n';

    return 0;
}
/*

5
1 2
2 3
3 4
4 5

// probati bojenje sahovski
*/