#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

typedef pair<int,int> pii;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pdd;

#define ff(i,a,b) for(int i = a; i <= b; i++)
#define fb(i,b,a) for(int i = b; i >= a; i--)
#define trav(a,x) for (auto& a : x)

#define sz(a) (int)(a).size()
#define pb push_back
#define fi first
#define se second
#define lb lower_bound
#define ub upper_bound
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) the number of elements in the os less than k
// *os.find_by_order(k)  print the k-th smallest number in os(0-based)

const int mod = 1000000007;
const int inf = 1e9 + 5;
const int mxN = 200005;

int n;

vector<int> g[mxN];

int dmx1[mxN];
int dmx2[mxN];

void bfs(int s, int d[]){
    ff(i,1,n)d[i] = inf;

    queue<int> q; q.push(s);
    d[s] = 0;

    while(sz(q)){
        int v = q.front(); q.pop();
        for(auto u : g[v]){
            if(d[u] == inf){
                d[u] = d[v] + 1;
                q.push(u);
            }
        }
    }

}

int par[mxN];
int dist[mxN];
void dfs2(int v, int p){
    par[v] = p;
    for(auto u : g[v]){
        if(u != p){
            dist[u] = dist[v] + 1;
            dfs2(u, v);
        }
    }
}
vector<int> Solve(){
    dfs2(1, -1);

    int mx = 0;
    ff(i,1,n)if(dist[mx] < dist[i])mx = i;

    dfs2(mx, -1);

    int dia = 0;
    ff(i,1,n)if(dist[dia] < dist[i])dia = i;

    vector<int> put;
    for(int A = dia; A != -1; A = par[A])put.pb(A);

    return put;

}


int pref[mxN];
int sufi[mxN];

int mx = 0;
bool visited[mxN];
void dfs_sufi(int v){
    mx = max(mx, dmx2[v]); visited[v] = 1;
    for(auto u : g[v]){
        if(!visited[u])dfs_sufi(u);
    }
}
void dfs_pref(int v){
    mx = max(mx, dmx1[v]); visited[v] = 1;
    for(auto u : g[v]){
        if(!visited[u])dfs_pref(u);
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    // da li je root uvek sredina diametra

    cin >> n;
    ff(i,1,n - 1){
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }

    // da li je najbolji root na diametru

    vector<int> put = Solve();

    if(sz(put) == 3){

        cout << put[0] << " " << put.back() << '\n';
        cout << put[1] << '\n';
        return 0;

    }

    int mx1 = put[0];
    int mx2 = put.back();

    bfs(mx1, dmx1);
    bfs(mx2, dmx2);

    // znam da su kandidati oni na diametru

    for(auto c : put)visited[c] = 1;

    fb(i,sz(put) - 1,0){
        int v = put[i];
        mx = 0; dfs_sufi(v);
        sufi[i] = max(sufi[i + 1], mx);
    }

    ff(i,1,n)visited[i] = 0;

    for(auto c : put)visited[c] = 1;

    ff(i,0,sz(put) - 1){
        int v = put[i];
        mx = 0; dfs_pref(v);
        if(i == 0)pref[i] = mx;
        else pref[i] = max(pref[i - 1], mx);
    }

    int rez = inf;
    int ko = 0;
    ff(i,0,sz(put) - 1){
        int root = put[i];

        if(dmx1[root] <= dmx2[root]){
            // levo

            int l = dmx1[root], r = n, ans = n;
            while(l <= r){
                int mid = (l + r) / 2;
                if(sufi[i + mid + 1] <= 2 * (mid - 1)){
                    ans = mid;
                    r = mid - 1;
                }
                else l = mid + 1;
            }

            if(ans < rez){
                rez = ans;
                ko = i;
            }

        }
        else{
            // desno

            break;

        }

    }
//
//    cout << "ko: " << ko << endl;
//    cout << "rez: " << rez << endl;

    // ko - root
    // edge izmedju ko i necega

    ff(i,1,n)visited[i] = 0;

    ff(i,0,ko + rez){
        visited[i] = 1;
    }

    // trazim diametrar tamo

    dist[mx2] = 0; dfs2(mx2, -1);

    int dia = 0;
    ff(i,1,n){
        if(!visited[i]){
            if(dist[dia] < dist[i]){
                dia = i;
            }
        }
    }

    vector<int> A;
    for(int u = dia; u != -1; u = par[u])A.pb(u);

    cout << put[ko] << " " << A[sz(A) / 2] << '\n';
    cout << put[ko] << '\n';

    return 0;
}
/*

10
1 2
2 3
3 4
4 5
5 6
6 7
7 8
8 9
9 10

// probati bojenje sahovski
*/